<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<ui:composition xmlns:h="http://java.sun.com/jsf/html" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:gdk="http://www.ihe.net/gazellecdk" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:rich="http://richfaces.org/rich" xmlns:f="http://java.sun.com/jsf/core"
                xmlns:gri="http://java.sun.com/jsf/composite/gri" xmlns:g="http://www.ihe.net/gazelle"
                xmlns:a4j="http://richfaces.org/a4j" xmlns="http://www.w3.org/1999/xhtml"
                template="/layout/template.xhtml">
    <ui:define name="body">
        <h1>#{messages['net.ihe.gazelle.ListOfBuildingBlockRepositoryBasedValidators']}</h1>
        <s:div id="globalDiv">
            <h:form id="globalForm">
                <div class="row">
                    <div class="col-md-12">
                        <ui:decorate template="/layout/panels/_panel_filter_criteria_footer.xhtml">
                            <ui:param name="sub_title"
                                      value="#{buildingBlockRepositoryListManager.buildingBlockRepositoryList.size()} #{messages['net.ihe.gazelle.BBRFoundForThisSearch']}"/>
                            <div class="row">
                                <div class="col-md-4">
                                    <ui:include src="/filter/filter.xhtml">
                                        <ui:param name="filter" value="#{buildingBlockRepositoryListManager.filter}"/>
                                        <ui:param name="filterId" value="label"/>
                                        <ui:param name="filterName"
                                                  value="#{messages['net.ihe.gazelle.ValidatorName']}"/>
                                        <ui:param name="filterForm" value="globalForm"/>
                                    </ui:include>
                                </div>
                                <div class="col-md-4">
                                    <ui:include src="/filter/filter.xhtml">
                                        <ui:param name="filter" value="#{buildingBlockRepositoryListManager.filter}"/>
                                        <ui:param name="filterId" value="url"/>
                                        <ui:param name="filterName"
                                                  value="#{messages['net.ihe.gazelle.cdagen.URL']}"/>
                                        <ui:param name="filterForm" value="globalForm"/>
                                    </ui:include>
                                </div>
                                <div class="col-md-4">
                                    <ui:include src="/filter/filter.xhtml">
                                        <ui:param name="filter" value="#{buildingBlockRepositoryListManager.filter}"/>
                                        <ui:param name="filterId" value="active"/>
                                        <ui:param name="filterName"
                                                  value="#{messages['net.ihe.gazelle.Active']}"/>
                                        <ui:param name="filterForm" value="globalForm"/>
                                    </ui:include>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-md-4">
                                    <ui:include src="/filter/filter.xhtml">
                                        <ui:param name="filter" value="#{buildingBlockRepositoryListManager.filter}"/>
                                        <ui:param name="filterId" value="version"/>
                                        <ui:param name="filterName"
                                                  value="#{messages['gazelle.simulator.version']}"/>
                                        <ui:param name="filterForm" value="globalForm"/>
                                    </ui:include>
                                </div>
                                <div class="col-md-4">
                                    <ui:include src="/filter/filter.xhtml">
                                        <ui:param name="filter" value="#{buildingBlockRepositoryListManager.filter}"/>
                                        <ui:param name="filterId" value="status"/>
                                        <ui:param name="filterName"
                                                  value="#{messages['net.ihe.gazelle.Status']}"/>
                                        <ui:param name="filterForm" value="globalForm"/>
                                    </ui:include>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-md-4">
                                    <ui:include src="/filter/filterDate.xhtml">
                                        <ui:param name="filter" value="#{buildingBlockRepositoryListManager.filter}"/>
                                        <ui:param name="filterId" value="creationDate"/>
                                        <ui:param name="filterName" value="#{messages['net.ihe.gazelle.cdagen.CreationDate']}"/>
                                        <ui:param name="filterForm" value="globalForm"/>
                                    </ui:include>
                                </div>
                                <div class="col-md-4">
                                    <ui:include src="/filter/filterDate.xhtml">
                                        <ui:param name="filter" value="#{buildingBlockRepositoryListManager.filter}"/>
                                        <ui:param name="filterId" value="buildingDate"/>
                                        <ui:param name="filterName" value="#{messages['net.ihe.gazelle.BuildingDate']}"/>
                                        <ui:param name="filterForm" value="globalForm"/>
                                    </ui:include>
                                </div>
                            </div>
                            <ui:define name="filter_buttons">
                                <a4j:commandLink title="#{messages['net.ihe.gazelle.Refresh']}"
                                                 render="globalForm,bbrTable">
                                    <span class="fa fa-refresh"/>
                                </a4j:commandLink>
                                <a4j:commandLink
                                        title="#{messages['net.ihe.gazelle.assertion-manager.ResetFilter']}"
                                        actionListener="#{buildingBlockRepositoryListManager.clearFilter()}"
                                        render="globalForm,">
                                    <span class="fa fa-times-circle"/>
                                </a4j:commandLink>
                            </ui:define>
                        </ui:decorate>
                    </div>
                </div>

                <ui:decorate template="/layout/panels/_panel_title_footer.xhtml">
                    <ui:define name="panel_title">#{messages['net.ihe.gazelle.ListOfBuildingBlockRepositoryBasedValidators']}
                    </ui:define>
                    <rich:dataTable id="bbrTable"
                                    value="#{buildingBlockRepositoryListManager.buildingBlockRepositoryList}"
                                    var="bbr">
                        <g:column sortBy="#{'id'}"
                                  sortOrder="ascending">
                            <ui:define name="header">#{messages['net.ihe.gazelle.cdagen.ID']}</ui:define>
                            <h:outputText value="#{bbr.id}"/>
                        </g:column>
                        <g:column sortBy="#{'label'}">
                            <ui:define name="header">#{messages['net.ihe.gazelle.ValidatorName']}</ui:define>
                            <h:outputText value="#{bbr.label}"/>
                        </g:column>
                        <g:column sortBy="#{'version'}">
                            <ui:define name="header">#{messages['gazelle.simulator.version']}</ui:define>
                            <h:outputText value="#{bbr.version}"/>
                        </g:column>
                        <g:column sortBy="#{'creationDate'}">
                            <ui:define name="header">#{messages['net.ihe.gazelle.cdagen.CreationDate']}</ui:define>
                            <h:outputText value="#{bbr.creationDate}"/>
                        </g:column>
                        <g:column sortBy="#{'buildingDate'}">
                            <ui:define name="header">#{messages['net.ihe.gazelle.BuildingDate']}</ui:define>
                            <h:panelGroup rendered="#{!bbr.alreadyBuilt()}">
                                <h:outputText value="#{messages['net.ihe.gazelle.NeverBuilt']}"/>
                            </h:panelGroup>
                            <h:panelGroup rendered="#{bbr.alreadyBuilt()}">
                                <h:outputText value="#{bbr.buildingDate}"/>
                            </h:panelGroup>
                        </g:column>
                        <g:column sortBy="#{'status'}">
                            <ui:define name="header">#{messages['net.ihe.gazelle.Status']}</ui:define>
                            <h:outputText value="#{bbr.currentStatus}"/>
                        </g:column>
                        <g:column sortBy="#{'active'}">
                            <ui:define name="header">#{messages['net.ihe.gazelle.Active']}</ui:define>
                            <h:outputText value="#{bbr.active}"/>
                        </g:column>
                        <g:column>
                            <ui:define name="header">#{messages['net.ihe.gazelle.cdagen.Action']}</ui:define>
                            <h:panelGroup styleClass="gzl-never-wrap">
                                <h:outputLink
                                        title="#{messages['net.ihe.gazelle.View']}"
                                        value="#{request.contextPath}/admin/buildingBlockRepository/view.seam">
                                    <f:param name="bbrId" value="#{bbr.id}"/>
                                    <span class="gzl-icon-search"/>
                                </h:outputLink>
                                <h:outputLink
                                        title="#{messages['net.ihe.gazelle.cdagen.Edit']}"
                                        value="#{request.contextPath}/admin/buildingBlockRepository/edit.seam">
                                    <f:param name="bbrId" value="#{bbr.id}"/>
                                    <span class="gzl-icon-pencil"/>
                                </h:outputLink>
                                <a4j:commandLink event="click"
                                                 title="#{messages['net.ihe.gazelle.Delete']}"
                                                 oncomplete="jq162('#deleteBBRPopup').modal('show');"
                                                 render="deleteBBRForm,globalForm"
                                                 actionListener="#{buildingBlockRepositoryManager.setSelectedBuildingBlockRepository(bbr)}">
                                    <span class="gzl-icon-trash-o"/>
                                </a4j:commandLink>
                                <h:panelGroup rendered="#{!bbr.isOnline()}">
                                    <h:commandLink
                                            title="#{messages['net.ihe.gazelle.DownloadBBRXML']}"
                                            action="#{bbr.download()}">
                                        <span class="gzl-icon-download"/>
                                    </h:commandLink>
                                </h:panelGroup>
                                <h:panelGroup rendered="#{bbr.isOnline()}">
                                    <h:outputLink
                                            title="#{messages['net.ihe.gazelle.DownloadBBRXML']}"
                                            value="#{bbr.url}">
                                        <span class="gzl-icon-download"/>
                                    </h:outputLink>
                                </h:panelGroup>
                                <h:panelGroup rendered="#{bbr.active and !bbr.isCompiling()}">
                                    <a4j:commandLink id="buildButton"
                                                     title="#{messages['net.ihe.gazelle.BuildBBR']}"
                                                     actionListener="#{buildingBlockRepositoryListManager.build(bbr.id)}"
                                                     render="bbrTable">
                                        <span class="gzl-icon-play"></span>
                                    </a4j:commandLink>
                                    <h:panelGroup rendered="#{bbr.isBuilt()}">
                                        <a4j:commandLink
                                                title="#{messages['net.ihe.gazelle.DeployDocumentation']}"
                                                actionListener="#{buildingBlockRepositoryListManager.deployDocumentation(bbr)}">
                                            <span class="gzl-icon-book"/>
                                        </a4j:commandLink>
                                    </h:panelGroup>
                                </h:panelGroup>
                                <h:outputLink
                                        title="#{messages['net.ihe.gazelle.DownloadGeneratedValidatorZIPArchive']})"
                                        rendered="#{bbr.archiveIsAvailable()}"
                                        value="#{request.contextPath}/rest/bbr/downloadBBRZip/#{bbr.id}">
                                    <span class="fa fa-file-archive-o"/>
                                </h:outputLink>
                                <h:outputLink
                                        title="#{messages['net.ihe.gazelle.ShowLogs']}"
                                        value="#{request.contextPath}/admin/buildingBlockRepository/log.seam">
                                    <f:param name="bbrId" value="#{bbr.id}"/>
                                    <span class="gzl-icon-gears"/>
                                </h:outputLink>
                            </h:panelGroup>
                        </g:column>
                        <f:facet name="footer">
                            <rich:dataScroller id="ds" render="bbrTable" maxPages="5"
                                               renderIfSinglePage="false"></rich:dataScroller>
                        </f:facet>
                    </rich:dataTable>
                    <ui:define name="panel_footer">
                        <h:outputLink value="#{request.contextPath}/admin/buildingBlockRepository/new.seam"
                                      styleClass="gzl-btn-green">
                            <h:outputText
                                    value="#{messages['net.ihe.gazelle.CreateBBR']}"/>
                        </h:outputLink>
                    </ui:define>
                </ui:decorate>
            </h:form>
        </s:div>

        <h:form id="deleteBBRForm">
            <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
                <ui:param name="popup_id" value="deleteBBRPopup"/>
                <ui:define name="popup_title">
                    <h:outputText
                            value="#{messages['net.ihe.gazelle.DeleteBuildingBlockRepository']}"/>
                </ui:define>
                <h:outputText id="deleteBBRText"
                              value="#{messages['net.ihe.gazelle.DoYouWantToDeleteTheBBRNamed']} #{buildingBlockRepositoryManager.getSelectedBuildingBlockRepository().getLabel()}?"/>

                <ui:define name="popup_footer">
                    <h:commandButton value="#{messages['net.ihe.gazelle.cdagen.Cancel']}"
                                     styleClass="gzl-btn"
                                     onclick="jq162('#deleteBBRPopup').modal('hide');"/>
                    <h:commandButton value="#{messages['net.ihe.gazelle.Delete']}"
                                     action="#{buildingBlockRepositoryManager.deleteSelectedBuildingBlockRepository()}"
                                     styleClass="gzl-btn-red" render="globalForm"
                                     onclick="jq162('#deleteBBRPopup').modal('hide');"/>
                </ui:define>
            </ui:decorate>
        </h:form>
    </ui:define>
</ui:composition>
